include:
  - template: Code-Quality.gitlab-ci.yml
  - template: Security/License-Scanning.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml

stages:
  - visualize
  - install
  - test

install dependencies:
  image: node:latest
  stage: install
  script:
    - npm install
  # This folder is cached between builds
  # http://docs.gitlab.com/ce/ci/yaml/README.html#cache
  cache:
    key: "$CI_COMMIT_REF_SLUG"
    paths:
      - node_modules/
    policy: push

test:lint:
  image: node:latest
  stage: test
  dependencies:
    - install dependencies
  script:
    - npm run lint:ci
  # This folder is cached between builds
  # http://docs.gitlab.com/ce/ci/yaml/README.html#cache
  cache:
    key: "$CI_COMMIT_REF_SLUG"
    paths:
      - node_modules/
    policy: pull
  artifacts:
    when: always
    paths:
      - lint/report.json
    expose_as: lint

test:vulnerabilities:
  image: node:latest
  stage: test
  dependencies:
    - install dependencies
  allow_failure: true
  script:
    - npm audit
  # This folder is cached between builds
  # http://docs.gitlab.com/ce/ci/yaml/README.html#cache
  cache:
    key: "$CI_COMMIT_REF_SLUG"
    paths:
      - node_modules/
    policy: pull

test:core:
  image: node:latest
  stage: test
  dependencies:
    - install dependencies
  script:
    - npm run test:ci
  # This folder is cached between builds
  # http://docs.gitlab.com/ce/ci/yaml/README.html#cache
  cache:
    key: "$CI_COMMIT_REF_SLUG"
    paths:
      - node_modules/
    policy: pull
  coverage: /All files[^|]*\|[^|]*\s+([\d\.]+)/
  artifacts:
    when: always
    paths:
      - coverage
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage/cobertura-coverage.xml
      junit: coverage/junit.xml
    expire_in: 30 days

code-navigation:
  stage: visualize
  image: sourcegraph/lsif-node:latest
  allow_failure: true # recommended
  script:
    - lsif-tsc -p .
  artifacts:
    reports:
      lsif: dump.lsif
  except:
    - master
    - /^v\d+\.\d+/
